#include <iostream>
#include <typeinfo>
using namespace std;

template<class T>
struct is_integral {
  static const bool value=false;
};

template<>
struct is_integral<int> {
  static const bool value=true;
};

template<>
struct is_integral<bool> {
  static const bool value=true;
};


template<bool , typename Return=void>
struct Enable_if {
  typedef Return value;
};

template<>
struct Enable_if<false,void> {};

template<class T>
typename Enable_if<is_integral<T>::value>::value
test(T& a) {
}

int
main() {
  int i;
  bool b;
  float f;

  test(b);
  //  test(f);
  return 0;
}
